<!DOCTYPE html>
<html lang="en">

<head>
    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
    <!-- vùng header -->
    <div class="container">
        <div class=" text-center mt-3">
            <h3>F12 - Quản trị Users </h3>
        </div>
        <div class=" form-group">
            <button class="btn btn-success"><i class="fa fa-plus"> </i>&nbsp; New User </button>
        </div>
    </div>

    <!-- vùng user data table -->
    <div class="container">
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict"
    const gPAGE_URL = "http://203.171.20.210:8080/crud-api/users/";
    // biến toàn cục để lưu trữ id user
    var gUserID = 0;

    const gUSER_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

    const gID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTEER_STATUS_COL = 6;
    const gACTION_COL = 7;

    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gUSER_COL[gID_COL] },
            { data: gUSER_COL[gFIRST_NAME_COL] },
            { data: gUSER_COL[gLAST_NAME_COL] },
            { data: gUSER_COL[gCOUNTRY_COL] },
            { data: gUSER_COL[gSUBJECT_COL] },
            { data: gUSER_COL[gCUSTOMER_TYPE_COL] },
            { data: gUSER_COL[gREGISTEER_STATUS_COL] },
            { data: gUSER_COL[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent:
                    ` 
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
            }
        ]

    })
    onPageLoading();
    // gán sựu kiên edit -Sửa
    $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
    })

    // gán sựu kiên delete - Xóa
    $(document).on("click", "#user-table .delete-user", function () {
        onBtnDeleteUserClick(this);
    })

    function onPageLoading() {
        getAllData();
    }
    // hàm xử lý sự kiện khi icon edit đưọc ấn
    function onBtnEditUserClick(pagramBtnEdit) {
        gUserID = getUserIdFromButton(pagramBtnEdit);
        console.log("ID tương ứng là:" + gUserID)
    }

    // hàm xử lý sự kiện khi icon delete đưọc ấn
    function onBtnDeleteUserClick(pagramBtnDelete) {
        gUserID = getUserIdFromButton(pagramBtnDelete);
        console.log("ID tương ứng là:" + gUserID)

    }

    function getAllData() {
        $.ajax({
            url: gPAGE_URL,
            type: "GET",
            dataType: "json",
            success: function (pagramUser) {
                console.log(pagramUser)
                loadDataToTable(pagramUser)
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }

        })
    }
    function loadDataToTable(pagram) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(pagram);
        vTable.draw()
    }


    function getUserIdFromButton(pagramBtn) {
        var vRowTable = $(pagramBtn).closest("tr");
        var vUserRowData = gUserTable.row(vRowTable).data();
        return vUserRowData.id;
    }
</script>
</body>

</html>